#include "phylo-stability.h"
int main(int argc, char **argv)
{
  FILE *treefile,*infile,*namefile,*btreefile;
  char value[1000],opt,(*names)[11];
  int ntaxa,*du,nft,nftm,i,*ftaxa,has_names,no_opt,lmax,j,*splits,B,b;
  int is_present,nb;
  double *utreec,bp;
  
  infile=NULL; treefile=NULL; btreefile=NULL;
  argc--;
  while((opt=get_param(&argc,argv,value)) != 'z'){
    no_opt=1;
    /* printf("%c %s\n",opt,value); */
    if(opt=='m') {ntaxa=atoi(value); no_opt=0;}
    if(opt=='t') {treefile=fopene(value,"r","treefile not available\n"); no_opt=0;}
    if(opt=='i') {infile=fopene(value,"r","infile not available"); no_opt=0;}
    if(opt=='o') {namefile=fopen(value,"w"); no_opt=0;}
    if(opt=='b'){
      btreefile=fopene(value,"r","bootstrap treefile not available\n"); 
      no_opt=0;
    }
    if(no_opt) {printf("Option %c not available\n",opt); exit(1);}  
  }
  if(btreefile==NULL){
    printf("bootstrap treefile needed: -b treefile"); exit(1);
  }
  if(infile==NULL){
    if(ntaxa<0) {printf("number of taxa needed: -m m\n"); exit(1);}
    if(namefile==NULL) namefile=fopen("infile","w");
  }
  if(treefile==NULL){
    printf("treefile needed\n");
    exit(1);
  }
  
  if(infile==NULL){
    names=(char (*)[11]) malloc((size_t) ntaxa*sizeof(*names));
    has_names=0;
  }
  else{
    ntaxa=names_infile(infile,&names,0);
    has_names=1;
  }
  utreec=(double *)malloc(4*ntaxa*sizeof(double));
  read_treecsnl(treefile,ntaxa,names,utreec,has_names);
  if(has_names==0){
    fprintf(namefile,"%i 1\n",ntaxa);
    for(lmax=0,i=0; i<ntaxa; i++) lmax = max(lmax,lstring(names[i]));
    if(lmax<=10) lmax=10;
    for(i=0; i<ntaxa; i++){
      j=0;
      while(names[i][j]!='\0'){
	putc(names[i][j],namefile);
	j++;
      }
      while(j<lmax+1){
	putc(' ',namefile);
	j++;
      }
      fprintf(namefile,"A\n");
    }
  }
  /* pr_utreec(stdout,ntaxa,utreec); */

  du=(int *)malloc(ntaxa*(ntaxa-1)*sizeof(int));
  bp=ntaxa; /* integer product too large */
  bp=(bp*(bp-1)*(bp-2)*(bp-3))/24;
  nftm=bp;
  ftaxa=(int *)malloc(6*nftm*sizeof(int));
  utreec2du(ntaxa,utreec,du);
  du2fgp(ntaxa,utreec,du);

  nft=du2ftaxa(ntaxa,utreec,du,ftaxa);

  B=ntrees_treefile(btreefile);
  splits=(int *) malloc(ntaxa*(ntaxa-3)*sizeof(int));
  
  for(i=0; i<nft; i++) ftaxa[5+i*6]=0.0;
  for(b=0; b<B; b++){
    read_treecsnl(btreefile,ntaxa,names,utreec,1);
    utreec2splits(ntaxa,utreec,splits);
    for(i=0; i<nft; i++){
      is_present=0;
      for(j=0; j<ntaxa-3; j++)
	if(check_split_ftaxa(&splits[j*ntaxa],&ftaxa[i*6])){
	  is_present=1;
	  break;
	}
      if(is_present) ftaxa[5+i*6]++;
    }
  }

  for(b=ntaxa; b<2*ntaxa-3; b++)
    for(j=0; j<ntaxa; j++){
      bp=0;
      nb=0;
      for(i=0; i<nft; i++)
	if(ftaxa[4+i*6]==b &&
	   (ftaxa[0+i*6]==j || ftaxa[1+i*6]==j || ftaxa[2+i*6]==j ||
	    ftaxa[3+i*6]==j)){
	  bp += ftaxa[5+i*6];
	  nb++;
	}
      for(i=0; i<10; i++) putchar(names[j][i]); printf(" ");
      printf("%4i %11.5f\n",b,(100.0*bp)/(B*nb));
    }
  return(0);
}
