#include "phylo-stability.h"
int main(int argc, char **argv)
{
  FILE *treefile,*otreefile,*bootfile,*seqfile;
  char value[1000],opt,(*names)[11];
  int no_opt,*s,*sb,ntaxa,*rbic,B,b,st,is_pres,sbt,sum,j,jd,*is_presr,k;
  double *utreec;

  treefile=NULL; otreefile=NULL; bootfile=NULL; seqfile=NULL;
  argc--;
  while((opt=get_param(&argc,argv,value)) != 'z'){
    no_opt=1;
    /* printf("%c %s\n",opt,value); */
    if(opt=='b'){
      bootfile=fopene(value,"r","bootstrap treefile not available\n"); 
      no_opt=0;
    }
    if(opt=='t'){
      treefile=fopene(value,"r","treefile not available"); 
      no_opt=0;
    }
    if(opt=='o'){
      otreefile=fopen(value,"w"); 
      no_opt=0;
    }
    if(opt=='i'){
      seqfile=fopene(value,"r","sequence file not available"); 
      no_opt=0;
    }
    if(no_opt) {printf("Option %c not available\n",opt); exit(1);}  
  }
  if(bootfile==NULL){
    printf("bootfile needed: -b bootfile \n"); exit(1);
  }
  if(treefile==NULL){
    printf("treefile needed: -t treefile\n"); exit(1);
  }
  if(seqfile==NULL){
    printf("sequence file needed: -i seqfile\n"); exit(1);
  }

  ntaxa=names_infile(seqfile,&names,0);

  utreec = (double *) malloc((size_t) (ntaxa-1)*4*sizeof(double));
  s = (int *) malloc((size_t) ntaxa*(ntaxa-3)*sizeof(int));
  sb = (int *) malloc((size_t) ntaxa*(ntaxa-3)*sizeof(int));
  rbic = (int *) malloc((size_t) ntaxa*(ntaxa-3)*sizeof(int));
  is_presr = (int *) malloc((size_t) ntaxa*sizeof(int));

  read_treecsnl(treefile,ntaxa,names,utreec,1);
  if(otreefile!=NULL) pr_tstr_labels(otreefile,ntaxa,utreec,names);
  utreec2splits(ntaxa,utreec,s);

  for(j=0; j<ntaxa*(ntaxa-3); j++) rbic[j]=0;

  B=ntrees_treefile(bootfile);
  
  for(b=0; b<B; b++){
    read_treecsnl(bootfile,ntaxa,names,utreec,1);
    utreec2splits(ntaxa,utreec,sb);
    /* printf("%i\n",b); */
    
    for(st=0; st<ntaxa-3; st++){
      /* wirow(stdout,ntaxa,&s[st*ntaxa],1); printf("\n"); */
      is_pres=0;
      for(j=0; j<ntaxa; j++) is_presr[j]=0;
      for(sbt=0; sbt<ntaxa-3; sbt++){
	/* wirow(stdout,ntaxa,&s[sbt*ntaxa],1);  */
	for(sum=0, j=0; j<ntaxa; j++)
	  if(s[j+st*ntaxa] != sb[j+sbt*ntaxa]){
	    sum++; jd=j;
	  }
	/* printf("sum:%i\n",sum); */
	if(sum==0){ is_pres=1; break; }
	if(sum==1) is_presr[jd]=1;
      }
      if(is_pres){
	for(j=0; j<ntaxa; j++) is_presr[j]=1;
      }
      for(j=0; j<ntaxa; j++) rbic[j+st*ntaxa] += is_presr[j];
    }
    
  }

  /* re-adjust cherries */
  for(st=0; st<ntaxa-3; st++){ 
    for(sum=0, j=0; j<ntaxa; j++) sum += s[j+st*ntaxa];
    if(sum==2)
      for(j=0; j<ntaxa; j++)
  	if(s[j+st*ntaxa]==1) rbic[j+st*ntaxa]=-(B+1);
    if(sum==ntaxa-2)
      for(j=0; j<ntaxa; j++)
  	if(s[j+st*ntaxa]==0) rbic[j+st*ntaxa]=-(B+1);
  }

  /* re-adjust splits defined by taxa */
  for(j=0; j<ntaxa; j++){
    for(st=0; st<ntaxa-3; st++){
      for(sbt=st+1; sbt<ntaxa-3; sbt++){
	for(sum=0,k=0; k<ntaxa; k++)
	  if(k!=j && s[k+st*ntaxa]!=s[k+sbt*ntaxa]) sum++;
	if(sum==0 || sum==ntaxa-1) break;
      }
      if(sum==0 || sum==ntaxa-1) break;
    }
    if(sum==0 || sum==ntaxa-1){
      rbic[j+st*ntaxa]=-rbic[j+st*ntaxa]; 
      rbic[j+sbt*ntaxa]=-rbic[j+sbt*ntaxa];
    }
  }
  
  /* wimat(stdout,ntaxa,ntaxa-3,rbic); */

  for(b=0; b<ntaxa-3; b++)
    for(j=0; j<ntaxa; j++){
      for(k=0; k<10; k++) putchar(names[j][k]); printf(" ");
      printf("%4i ",b+ntaxa);
      printf("%11.5f\n",(100.0*rbic[j+b*ntaxa])/B);
    }

  
  /* for(b=0; b<ntaxa-3; b++) */
  /*   for(j=0; j<ntaxa; j++){ */
  /*     for(k=0; k<10; k++) putchar(names[j][k]); printf(" "); */
  /*     printf("%4i ",b+ntaxa); */
  /*     printf("%i\n",rbic[j+b*ntaxa]); */
  /*   } */
  return(0);
}
