#include "phylo-stability.h"
int main(int argc, char **argv)
{
  FILE *infile;
  char value[1000],opt,(*names)[11];
  int no_opt,split=0,ntaxa,spl,nbp_spl,*nbp_taxa,j,i,fso,*dbl_taxa;
  double bp_spl,*bp_taxa,bp;
  
  infile=NULL;
  argc--;
  while((opt=get_param(&argc,argv,value)) != 'z'){
    no_opt=1;
    if(opt=='m'){ ntaxa=atoi(value); no_opt=0;}
    if(opt=='i'){
      infile=fopene(value,"r","input file is not available"); no_opt=0;
    }
    if(opt=='s'){split=1; no_opt=0;}
    if(no_opt) {printf("Option %c not available\n",opt); exit(1);}
  }
  if(infile==NULL){
    printf("file with output of rbic_taxon_split or bptaxon_split needed: -i infile\n");
    exit(1);
  }
  if(ntaxa<0){
    printf("specify number of taxa: -m ntaxa"); exit(1);
  }

  names=(char (*)[11]) malloc((size_t) ntaxa*sizeof(*names));
  nbp_taxa = (int *) malloc((size_t) ntaxa*sizeof(int));
  bp_taxa = (double *) malloc((size_t) ntaxa*sizeof(double));
  for(j=0; j<ntaxa; j++){bp_taxa[j]=0.0; nbp_taxa[j]=0;}

  /* when taxa is not in cherry, two branches become one upon deletion. */
  /* to not double count we utilize -BP entries */
  dbl_taxa = (int *) malloc((size_t) ntaxa*sizeof(int));
  for(j=0; j<ntaxa; j++){dbl_taxa[j]=0;}
 
  for(spl=0; spl<ntaxa-3; spl++){
    bp_spl=0.0; nbp_spl=0;
    for(j=0; j<ntaxa; j++){
      for(i=0; i<10; i++) names[j][i]=getc(infile);
      names[j][10]='\0';
      fso=fscanf(infile,"%i %lf",&i,&bp);
      if(fso<=0){
	printf("not as many entries in infile as expected"); exit(1);
      }
      /* printf("%s %i %f\n",names[j],i,bp); */
      while(getc(infile) !='\n') ;
      if(bp>-100.00001){
	bp_spl += bp; nbp_spl++;
	if(bp<0){
	  bp_spl -= bp; nbp_spl++;
	}
	if(bp<0 && !dbl_taxa[j]){
	  bp_taxa[j] -= bp; nbp_taxa[j]++;
	  dbl_taxa[j]=1;
	}
	if(bp>=0){
	  bp_spl += bp; nbp_spl++;
	  bp_taxa[j] += bp; nbp_taxa[j]++;
	}
      }
    }
    if(split) printf("%3i %6.2f\n",spl+ntaxa,bp_spl/nbp_spl);
  }

  if(!split)
    for(j=0; j<ntaxa; j++){
      for(i=0; i<10; i++) putchar(names[j][i]); printf(" ");
      /* printf("%6.2f\n",bp_taxa[j]/nbp_taxa[j]); */
      printf("%6.2f\n",bp_taxa[j]/nbp_taxa[j]);
    }
  return(0);
}
